import React from 'react';

import type { GeneralSizeProp } from '@/mui/types';

import { parseKeywordsToLabelsSelector } from '@/modules/feeds/Editor/redux/selectors';
import { setAction } from '@/modules/feeds/Editor/redux/slices';

import { useFormSettings } from '@/modules/@common/Form';
import { useAppDispatch, useAppSelector } from '@/modules/@common/store/hooks';
import { Switch } from '@/mui/components';

type PropTypes = {
  disabled?: boolean;
};

function UseForDownload({ disabled = false }: PropTypes) {
  const dispatch = useAppDispatch();
  const { size } = useFormSettings();

  const parseKeywordsToLabels = useAppSelector(parseKeywordsToLabelsSelector);

  return (
    <Switch
      data-id="parseKeywordsToLabels"
      size={size as GeneralSizeProp}
      color="primary"
      checked={parseKeywordsToLabels}
      disabled={disabled}
      onChange={(e) => dispatch(setAction({ parseKeywordsToLabels: e.target.checked }))}
    />
  );
}

export default UseForDownload;
